import { Message } from 'eris';
import { randomBytes } from 'crypto';
import { Client, Command } from '../class';

export default class AddMerchant extends Command {
  constructor(client: Client) {
    super(client);
    this.name = 'addmerchant';
    this.description = 'Creates a new merchant.';
    this.usage = `${this.client.config.prefix}addmerchant <merchant name>`;
    this.aliases = ['am'];
    this.permissions = 6;
    this.guildOnly = true;
    this.enabled = true;
  }

  public async run(message: Message, args: string[]) {
    try {
      if (!args[0]) return this.client.commands.get('help').run(message, [this.name]);
      const key = randomBytes(20).toString('hex');
      const merchant = await (new this.client.db.Merchant({
        name: args.join(' '),
        key,
        pulls: [],
      })).save();
      return this.success(message.channel, `Created merchant (${merchant._id}). \`${args.join(' ')}\`\n\n\`${key}\``);
    } catch (err) {
      return this.client.util.handleError(err, message, this);
    }
  }
}
