import { Document, Schema, model } from 'mongoose';

export interface MerchantInterface extends Document {
  name: string,
  key: string,
  /**
   * type
   * - 0: hard
   * - 1: soft
   */
  pulls: [{ type: 0 | 1, reason: string, date: Date }],
}

const Merchant: Schema = new Schema({
  name: String,
  key: String,
  pulls: Array,
});

export default model<MerchantInterface>('Merchant', Merchant);
